#!/bin/sh
# Startup script for WebGUI's Spectre Daemon
#
# Author:            Ernesto Hernández-Novich <emhn@usb.ve>
# Version:           @(#) webgui 1.1 2009-08-11 emhn@usb.ve
#
### BEGIN INIT INFO
# Provides:          webgui
# Required-Start:    $network $remote_fs $syslog
# Required-Stop:     $network $remote_fs $syslog
# Should-Start:      apache2
# Should-Stop:       apache2
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Startup WebGUI's Spectre daemon
# Description:       WebGUI includes a workflow handling daemon that
#                    must be started in order for publishing and other
#                    CMS related activities to complete properly.
### END INIT INFO

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/bin:/usr/sbin:/usr/bin
DESC="WebGUI's Spectre Daemon"
NAME=spectre
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="--options args"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/webgui

# Edit /etc/default/webgui to change this
ENABLED=no

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/webgui ] && . /etc/default/webgui

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start --quiet --pidfile $PIDFILE \
                      --exec $DAEMON --test > /dev/null  \
		|| return 1
	start-stop-daemon --start --quiet --pidfile $PIDFILE \
                      --exec $DAEMON -- --daemon \
		|| return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet \
                      --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet \
                      --oknodo --retry=0/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

if [ "$ENABLED" != "yes" ]
then
  log_daemon_msg "WebGUI's Spectre daemon disabled in /etc/default/webgui"
  log_end_msg 0
  exit 0
fi

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  restart|force-reload)
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  status)
    log_daemon_msg "Testing $DESC" "$NAME"
    echo
    $DAEMON --status
    log_end_msg 0
    ;;
  *)
	echo "Usage: $SCRIPTNAME {start|stop|restart|status|force-reload}" >&2
	exit 3
	;;
esac

:
